unit U_YGYPZZChkList_GWSQSH;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ToolWin, cxStyles, cxCustomData,
  cxGraphics, cxFilter, cxData, cxDataStorage, cxEdit, DB, cxDBData, ADODB,
  cxGridCustomPopupMenu, cxGridPopupMenu, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxGrid, DBClient, cxCheckBox, cxCalendar, cxSplitter,
  RM_Dataset, RM_System, RM_Common, RM_Class, RM_GridReport, RM_e_Xls,
  Menus, cxButtonEdit, cxDropDownEdit, cxPC;

type
  TfrmYGYPZZChkList_GWSQSH = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBClose: TToolButton;
    cxGridPopupMenu1: TcxGridPopupMenu;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    TBExport: TToolButton;
    Order_Main: TClientDataSet;
    TBView: TToolButton;
    Panel1: TPanel;
    TBLiZhi: TToolButton;
    PopupMenu1: TPopupMenu;
    N2: TMenuItem;
    N1: TMenuItem;
    TCXTJ: TToolButton;
    BegDate: TDateTimePicker;
    Label3: TLabel;
    EndDate: TDateTimePicker;
    cxTabControl1: TcxTabControl;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column7: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    v1SQStatus: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    cxGrid2: TcxGrid;
    TV2: TcxGridDBTableView;
    V2Chker: TcxGridDBColumn;
    V2Chktime: TcxGridDBColumn;
    V2Chkstatus: TcxGridDBColumn;
    V2chkNote: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    DataSource2: TDataSource;
    order_Sub: TClientDataSet;
    Label2: TLabel;
    v1SQDate: TcxGridDBColumn;
    v1SQNote: TcxGridDBColumn;
    TTiJiao: TToolButton;
    TCXSQ: TToolButton;
    TEdit: TToolButton;
    v1SQGangWei: TcxGridDBColumn;
    cxStyleRepository1: TcxStyleRepository;
    cxStyle1: TcxStyle;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure TBViewClick(Sender: TObject);
    procedure CustomerNoNameChange(Sender: TObject);
    procedure TBLiZhiClick(Sender: TObject);
    procedure TCXTJClick(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure Tv1CellDblClick(Sender: TcxCustomGridTableView;
      ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
      AShift: TShiftState; var AHandled: Boolean);
    procedure Tv1CellClick(Sender: TcxCustomGridTableView;
      ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
      AShift: TShiftState; var AHandled: Boolean);
    procedure TCXSQClick(Sender: TObject);
    procedure TTiJiaoClick(Sender: TObject);
    procedure TEditClick(Sender: TObject);
  private
    canshu1:string;
    DQdate:TDateTime;
    procedure InitGrid();
    procedure InitForm();
    function  DelData():Boolean;
    procedure setstatus();
    { Private declarations }
  public
    FFInt,FCloth:Integer;

    { Public declarations }
  end;

var
  frmYGYPZZChkList_GWSQSH: TfrmYGYPZZChkList_GWSQSH;

implementation
uses
  U_DataLink,U_RTFun,U_ZDYHelp, U_YGYPInPut,U_YGYPInPut_GWSQ,
  U_ZDYHelpSel;

{$R *.dfm}

procedure TfrmYGYPZZChkList_GWSQSH.setstatus();
begin
  TTiJiao.Visible:=False;
  TCXTJ.Visible:=False;
  case cxTabControl1.TabIndex of
    0:begin
        TTiJiao.Visible:=True;
        TCXTJ.Visible:=true;
      end;
    1:begin
      end;
    2:begin

      end;
  end;
end;

procedure TfrmYGYPZZChkList_GWSQSH.FormDestroy(Sender: TObject);
begin
  frmYGYPZZChkList_GWSQSH:=nil;
end;

procedure TfrmYGYPZZChkList_GWSQSH.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmYGYPZZChkList_GWSQSH.FormCreate(Sender: TObject);
begin
  canshu1:=Trim(DParameters1);
end;

procedure TfrmYGYPZZChkList_GWSQSH.TBCloseClick(Sender: TObject);
begin
  Close;
  WriteCxGrid('员工转职列表',Tv1,'OA管理');
end;

procedure TfrmYGYPZZChkList_GWSQSH.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      sql.Clear;
      sql.Add('select A.*,B.* ');
      sql.Add(' from OA_YG_DangAN_GWDD A  ');
      sql.add(' inner join OA_Chk B on B.Mainid=A.DDID and B.OAType=''岗位申请''');
      sql.Add(' where B.Chker='''+trim(DName)+'''');
      if cxTabControl1.TabIndex<>0 then
      begin
        sql.add(' and A.SQDate>='''+Trim(FormatDateTime('yyyy-MM-dd',BegDate.Date))+'''');
        sql.Add(' and A.SQDate<='''+Trim(FormatDateTime('yyyy-MM-dd',EndDate.Date+1))+'''');
      end;
      if cxTabControl1.TabIndex=0 then
      begin
        sql.Add(' and isnull(B.ChkStatus,'''')='''' ');
      end else
      if cxTabControl1.TabIndex=1 then
      begin
        sql.add(' and isnull(B.ChkStatus,'''')=''申请通过'' ');
      end;
      Open;
    end;
    SCreateCDS20(ADOQueryMain,Order_Main);
    SInitCDSData20(ADOQueryMain,Order_Main);
    with ADOQueryCmd do
    begin
      close;
      sql.clear;
      sql.add('select A.* from OA_Chk A ');
      sql.add('where A.Mainid='''+trim(Order_Main.fieldbyname('DDID').AsString)+''' ');
      sql.Add('and isnull(OAType,'''')=''岗位申请''');
      open;
    end;
    SCreateCDS20(ADOQueryCmd,Order_Sub);
    SInitCDSData20(ADOQueryCmd,Order_Sub);
  finally
    ADOQueryMain.EnableControls;
  end;
end;


procedure TfrmYGYPZZChkList_GWSQSH.InitForm();
begin
  EndDate.Date:=SGetServerDate(ADOQueryTemp);
  BegDate.Date:=EndDate.Date-7;
  ReadCxGrid('员工转职列表',Tv1,'OA管理');
  setstatus();
  InitGrid();
end;

procedure TfrmYGYPZZChkList_GWSQSH.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

function TfrmYGYPZZChkList_GWSQSH.DelData():Boolean;
begin
  try
    Result:=false;
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('Delete OA_YG_DangAn  where YGId='''+Trim(Order_Main.fieldbyname('YGId').AsString)+'''');
      ExecSQL;
    end;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('Delete OA_YG_DangAn_Other  where YGId='''+Trim(Order_Main.fieldbyname('YGId').AsString)+'''');
      ExecSQL;
    end;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('Delete TP_File  where WBId='''+Trim(Order_Main.fieldbyname('YGId').AsString)+'''');
      sql.Add(' and TFType=''YG'' ');
      ExecSQL;
    end;

    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Result:=False;
    Application.MessageBox('数据删除异常！','提示',0);
  end;
end;

procedure TfrmYGYPZZChkList_GWSQSH.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  TcxGridToExcel('员工转职列表',cxGrid1);
end;

procedure TfrmYGYPZZChkList_GWSQSH.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmYGYPZZChkList_GWSQSH.FormShow(Sender: TObject);
begin
  InitForm();
end;

procedure TfrmYGYPZZChkList_GWSQSH.CheckBox1Click(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmYGYPZZChkList_GWSQSH.CheckBox2Click(Sender: TObject);
begin
  TBRafresh.Click;
end;

procedure TfrmYGYPZZChkList_GWSQSH.TBViewClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  frmYGYPInPut_GWSQ:=TfrmYGYPInPut_GWSQ.create(self);
  with frmYGYPInPut_GWSQ do
  begin
    FDDID:=trim(Order_Main.fieldbyname('DDID').asstring);
    TBSave.Visible:=False;
    if showModal=1 then
    begin

    end;
    free;
  end;
end;

procedure TfrmYGYPZZChkList_GWSQSH.CustomerNoNameChange(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

procedure TfrmYGYPZZChkList_GWSQSH.TBLiZhiClick(Sender: TObject);
begin
  frmYGYPInPut_GWSQ:=TfrmYGYPInPut_GWSQ.create(self);
  with frmYGYPInPut_GWSQ do
  begin
    FDDID:='';
    if showModal=1 then
    begin

    end;
    free;
  end;
  initGrid();
end;

procedure TfrmYGYPZZChkList_GWSQSH.TCXTJClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  if Application.MessageBox('确定要执行撤销操作吗？','提示',32+4)<>IDYES then Exit;
  try
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('Update OA_YG_DangAN_GWDD Set SQStatus=''不通过''');
      sql.Add(' where DDID='''+Order_Main.fieldbyname('DDID').AsString+'''');
      ExecSQL;
    end;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('delete from OA_Chk ');
      sql.Add(' where Mainid='''+Order_Main.fieldbyname('DDID').AsString+'''');
      sql.Add(' and isnull(OAType,'''')=''岗位申请'' ');
      ExecSQL;
    end;
    initGrid();
    ADOQueryCmd.Connection.CommitTrans;
    Exit;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('操作异常!','提示',0);
  end;
end;

procedure TfrmYGYPZZChkList_GWSQSH.cxTabControl1Change(Sender: TObject);
begin
  setstatus();
  InitGrid();
end;

procedure TfrmYGYPZZChkList_GWSQSH.Tv1CellDblClick(Sender: TcxCustomGridTableView;
  ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
  AShift: TShiftState; var AHandled: Boolean);
begin
  TBView.Click;
end;

procedure TfrmYGYPZZChkList_GWSQSH.Tv1CellClick(Sender: TcxCustomGridTableView;
  ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
  AShift: TShiftState; var AHandled: Boolean);
begin
  with ADOQueryCmd do
  begin
    close;
    sql.clear;
    sql.add('select A.* from OA_Chk A ');
    sql.add('where A.Mainid='''+trim(Order_Main.fieldbyname('DDID').AsString)+''' ');
    sql.Add(' and isnull(OAType,'''')=''岗位申请'' ');
    open;
  end;
  SCreateCDS20(ADOQueryCmd,Order_Sub);
  SInitCDSData20(ADOQueryCmd,Order_Sub);
end;

procedure TfrmYGYPZZChkList_GWSQSH.TCXSQClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then exit;
  with ADOQueryCmd do
  begin
    close;
    sql.clear;
    sql.Add('delete from OA_YG_DangAN_GWDD ');
    sql.add('where DDID='''+trim(Order_Main.fieldbyname('DDID').AsString)+'''');
    execsql;
  end;
  application.MessageBox('撤销成功','提示');
  initGrid();
end;

procedure TfrmYGYPZZChkList_GWSQSH.TTiJiaoClick(Sender: TObject);
var maxno: string;
begin
  if Order_Main.IsEmpty then exit;
  try
    if trim(DParameters1)='高权限' then
    begin
      with ADOQueryCmd do
      begin
        Close;
        SQL.Clear;
        sql.Add('Update OA_Chk Set ');
        sql.Add(' ChkTime=getdate(),Chkstatus=''申请通过'' ');
        sql.Add(' where Mainid='''+trim(Order_Main.fieldbyname('Mainid').AsString)+''' ');
        sql.add('and OAType=''岗位申请''');
        ExecSQL;
      end;
    end
    else
    begin
      with ADOQueryCmd do
      begin
        Close;
        SQL.Clear;
        sql.Add('Update OA_Chk Set ');
        sql.Add(' ChkTime=getdate(),Chkstatus=''申请通过'' ');
        sql.Add(' where CKID='''+trim(Order_Main.fieldbyname('CKID').AsString)+''' ');
        ExecSQL;
      end;
    end;
    with ADOQueryCmd do
    begin
      close;
      sql.clear;
      sql.add('select A.* from OA_Chk A ');
      sql.add('where A.Mainid='''+trim(Order_Main.fieldbyname('Mainid').AsString)+''' ');
      sql.add('and isnull(A.Chkstatus,'''')<>''申请通过'' ');
      sql.add('and isnull(A.OAType,'''')=''岗位申请''');
      open;
    end;
    if ADOQueryCmd.IsEmpty then
    begin
      with ADOQueryMain do
      begin
        close;
        sql.Clear;
        sql.add('update OA_YG_DangAN_GWDD set ');
        sql.add('SQStatus=''申请通过'' ');
        sql.Add(' where DDID='''+trim(Order_Main.fieldbyname('DDID').AsString)+'''');
        execsql;
      end;
      with ADOQueryCmd do
      begin
        Close;
        SQL.Clear;
        sql.Add('Update OA_YG_DangAn Set GangWei='''+trim(Order_Main.fieldbyname('SQGangWei').AsString)+'''');
        sql.add(',DPID='''+trim(Order_Main.fieldbyname('DPID').AsString)+'''');
        sql.add(',Dept='''+trim(Order_Main.fieldbyname('SQDept').AsString)+'''');
        sql.Add(' where YGID='''+Order_Main.fieldbyname('YGID').AsString+'''');
        ExecSQL;
      end;
    end;
    application.MessageBox('审核成功','提示');
    initGrid();
  except;
    application.MessageBox('审核失败','提示');
    exit;
  end;
end;

procedure TfrmYGYPZZChkList_GWSQSH.TEditClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  frmYGYPInPut_GWSQ:=TfrmYGYPInPut_GWSQ.create(self);
  with frmYGYPInPut_GWSQ do
  begin
    FDDID:=trim(Order_Main.fieldbyname('DDID').asstring);
    if showModal=1 then
    begin

    end;
    free;
  end;
  initGrid();
end;

end.
